/* A Bison parser, made by GNU Bison 2.5.  */

/* Bison implementation for Yacc-like parsers in C
   
      Copyright (C) 1984, 1989-1990, 2000-2011 Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.5"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1

/* Using locations.  */
#define YYLSP_NEEDED 0



/* Copy the first part of user declarations.  */

/* Line 268 of yacc.c  */
#line 3 "trbison.y"


/*
 * $Id: trbison.y 370 2012-07-20 10:11:13Z jtk $
 *
 * $Log$
 * Revision 1.6  2005/06/22 09:58:36  jtk
 * prevented unknown variables from resulting in core-dump eliciting parsing results
 *
 * Revision 1.5  2005/06/15 22:17:13  jtk
 * counting number of transsys programs in lsys (deprecating multiples)
 *
 * Revision 1.4  2005/04/14 18:44:46  jtk
 * fixed parser slipthrough of symbols declared with nonexistent transsys programs
 *
 * Revision 1.3  2005/04/01 13:37:05  jtk
 * Made parser somewhat more strict
 *
 * Revision 1.2  2005/03/31 16:07:36  jtk
 * finished (initial) implementation of lsys diffusion
 *
 * Revision 1.1.1.1  2005/03/08 17:12:02  jtk
 * new cvs after loss at INB
 *
 * Revision 1.2  2003/01/22 11:39:24  kim
 * added dot.c
 *
 * Revision 1.1  2001/04/04 11:12:00  kim
 * Initial addition of files previously not CVS managed
 *
 */

#include <ctype.h>
#include <stdarg.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

#include "trconfig.h"
#include "transsys.h"


long lineno = 1;
char *yyin_name = NULL;
extern int yychar;


TRANSSYS *parsed_transsys = NULL;
LSYS *parsed_lsys = NULL;

static LSYS *current_lsys = NULL;
static TRANSSYS *current_transsys = NULL;

/*
 * current_factor appears to be necessitated only to provide
 * the obsolescent defaults to decay and diffusibility.
 */
static FACTOR_ELEMENT *current_factor = NULL;

/*
 * current_lhs_symbol_list effectively represents the namespace
 * of transsys programs associated with symbols, established by
 * the lefthand side of a rule. It is initialised upon parsing
 * the lhs and passed in as a parameter during parsing the rhs.
 * (Yes, this is a rather nasty hack.)
 */
static LHS_SYMBOL *current_lhs_symbol_list;


static void list_parsed_stuff(const char *msg)
{
  /* TRANSSYS *t; */
  LSYS *l;
  int indent = 0;

  if (msg)
  {
    fprintf(stderr, "list_parsed_stuff: %s\n", msg);
    indent = 4;
  }
  return;
/*
  for (t = parsed_transsys; t; t = t->next)
    fprint_transsys(stderr, indent, t);
*/
  for (l = parsed_lsys; l; l = l->next)
  {
    fprint_lsys(stderr, indent, l);
  }
}


static void ignore_message(char *format, ...)
{
  va_list ap;

  va_start(ap, format);
  fprintf(stderr, "%s:%ld: ignoring ", yyin_name, lineno);
  vfprintf(stderr, format, ap);
  fprintf(stderr, "\n");
}


/*** original transsys functions ***/

static int setup_current_factor(const char *name)
{
  current_factor = new_factor_element(name, NULL, NULL, NULL);
  if (current_factor == NULL)
  {
    yyerror("setup_current_factor failed");
    return (-1);
  }
  /* fprintf(stderr, "created factor \"%s\"\n", current_factor->name); */
  return (0);
}


static int setup_current_transsys(const char *name)
{
  current_transsys = new_transsys(name);
  if (current_transsys == NULL)
  {
    yyerror("failed to set up new transsys");
    return (-1);
  }
  return (0);
}


static int setup_current_lsys(const char *name)
{
  current_lsys = new_lsys(name);
  if (current_lsys == NULL)
  {
    yyerror("failed to set up new lsys");
    return (-1);
  }
  return (0);
}


static RULE_ELEMENT *complete_rule(const char *name, RULE_ELEMENT *re)
{
  strncpy(re->name, name, IDENTIFIER_MAX);
  re->name[IDENTIFIER_MAX - 1] = '\0';
  if (arrange_symbol_production_arrays(re->rhs) != 0)
  {
    yyerror("complete_rule: arrange_symbol_production_arrays() failed");
  }
  return (re);
}


/*
 * the set_factordef functions don't allow superseding an expression as multiple specification
 * of expressions is not useful and potentially dangerous.
 */
static int set_factordef_decay(EXPRESSION_NODE *decay_expression, FACTOR_ELEMENT *fe)
{
  if (fe->decay_expression != NULL)
  {
    yyerror("duplicate decay expression");
    return (-1);
  }
  add_factordef_decay(decay_expression, fe);
  return (0);
}


static int set_factordef_diffusibility(EXPRESSION_NODE *diffusibility_expression, FACTOR_ELEMENT *fe)
{
  if (fe->diffusibility_expression != NULL)
  {
    yyerror("duplicate diffusibility expression");
    return (-1);
  }
  add_factordef_diffusibility(diffusibility_expression, fe);
  return (0);
}


static int set_factordef_synthesis(EXPRESSION_NODE *synthesis_expression, FACTOR_ELEMENT *fe)
{
  if (fe->synthesis_expression != NULL)
  {
    yyerror("duplicate synthesis expression");
    return (-1);
  }
  add_factordef_synthesis(synthesis_expression, fe);
  return (0);
}



/* Line 268 of yacc.c  */
#line 268 "trbison.c"

/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 1
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif


/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     LOGICAL_OR = 258,
     LOGICAL_AND = 259,
     REALVALUE = 260,
     IDENTIFIER = 261,
     FACTOR_DEF = 262,
     GENE_DEF = 263,
     PROMOTER_DEF = 264,
     PRODUCT_DEF = 265,
     CONSTITUTIVE = 266,
     ACTIVATE = 267,
     REPRESS = 268,
     DEFAULT = 269,
     TRANSSYS_DEF = 270,
     DECAY_DEF = 271,
     DIFFUSIBILITY_DEF = 272,
     SYNTHESIS_DEF = 273,
     LSYS_DEF = 274,
     SYMBOL_DEF = 275,
     RULE_DEF = 276,
     AXIOM_DEF = 277,
     DIFFUSIONRANGE_DEF = 278,
     GRAPHICS_DEF = 279,
     ARROW = 280,
     MOVE = 281,
     COLOR = 282,
     SPHERE = 283,
     CYLINDER = 284,
     BOX = 285,
     TURN = 286,
     ROLL = 287,
     BANK = 288,
     PUSH = 289,
     POP = 290,
     LOWER_EQUAL = 291,
     GREATER_EQUAL = 292,
     EQUAL = 293,
     UNEQUAL = 294,
     NUMERIC_RANDOM = 295,
     NUMERIC_GAUSS = 296,
     NUMERIC_POW = 297,
     NUMERIC_LOG = 298,
     NUMERIC_ATAN = 299
   };
#endif
/* Tokens.  */
#define LOGICAL_OR 258
#define LOGICAL_AND 259
#define REALVALUE 260
#define IDENTIFIER 261
#define FACTOR_DEF 262
#define GENE_DEF 263
#define PROMOTER_DEF 264
#define PRODUCT_DEF 265
#define CONSTITUTIVE 266
#define ACTIVATE 267
#define REPRESS 268
#define DEFAULT 269
#define TRANSSYS_DEF 270
#define DECAY_DEF 271
#define DIFFUSIBILITY_DEF 272
#define SYNTHESIS_DEF 273
#define LSYS_DEF 274
#define SYMBOL_DEF 275
#define RULE_DEF 276
#define AXIOM_DEF 277
#define DIFFUSIONRANGE_DEF 278
#define GRAPHICS_DEF 279
#define ARROW 280
#define MOVE 281
#define COLOR 282
#define SPHERE 283
#define CYLINDER 284
#define BOX 285
#define TURN 286
#define ROLL 287
#define BANK 288
#define PUSH 289
#define POP 290
#define LOWER_EQUAL 291
#define GREATER_EQUAL 292
#define EQUAL 293
#define UNEQUAL 294
#define NUMERIC_RANDOM 295
#define NUMERIC_GAUSS 296
#define NUMERIC_POW 297
#define NUMERIC_LOG 298
#define NUMERIC_ATAN 299




#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
{

/* Line 293 of yacc.c  */
#line 200 "trbison.y"

  int integer;
  INTEGER_ARRAY *intarr;
  double real;
  char identifier[IDENTIFIER_MAX];
  EXPRESSION_NODE *expression;
  FACTOR_ELEMENT *factor;
  PROMOTER_ELEMENT *promoter;
  GENE_ELEMENT *gene;
  TRANSSYS *transsys;
  SYMBOL_ELEMENT *symbol_element;
  RULE_ELEMENT *rule_element;
  LHS_DESCRIPTOR *lhs_descriptor;
  LHS_SYMBOL *lhs_symbol;
  PRODUCTION_ELEMENT *production_element;
  SYMBOL_PRODUCTION *symbol_production;
  RAW_ASSIGNMENT *raw_assignment;
  GRAPHICS_PRIMITIVE *graphics_primitive;



/* Line 293 of yacc.c  */
#line 414 "trbison.c"
} YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif


/* Copy the second part of user declarations.  */


/* Line 343 of yacc.c  */
#line 426 "trbison.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(e) ((void) (e))
#else
# define YYUSE(e) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(n) (n)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (YYID (0))
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  4
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   327

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  63
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  47
/* YYNRULES -- Number of rules.  */
#define YYNRULES  114
/* YYNRULES -- Number of states.  */
#define YYNSTATES  298

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   299

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    59,     2,     2,     2,     2,     2,     2,
      52,    53,     5,     3,    57,     4,    62,     6,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    56,    49,
      60,    58,    61,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    54,     2,    55,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    50,     2,    51,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     7,     8,
       9,    10,    11,    12,    13,    14,    15,    16,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    47,    48
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     4,     7,    10,    13,    14,    21,    23,
      26,    28,    30,    32,    34,    36,    40,    47,    51,    58,
      62,    69,    73,    78,    84,    90,    94,    96,    97,   100,
     102,   107,   109,   110,   113,   115,   120,   122,   124,   127,
     129,   133,   134,   136,   140,   144,   149,   150,   153,   158,
     163,   168,   169,   172,   178,   183,   188,   194,   200,   206,
     212,   220,   230,   240,   241,   248,   249,   252,   255,   258,
     259,   266,   267,   270,   275,   280,   285,   292,   297,   302,
     303,   306,   311,   321,   331,   333,   337,   342,   346,   348,
     352,   354,   357,   359,   363,   367,   371,   375,   379,   383,
     385,   389,   393,   395,   399,   403,   405,   407,   411,   418,
     425,   432,   439,   444,   446
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int8 yyrhs[] =
{
      64,     0,    -1,    -1,    64,    65,    -1,    64,    89,    -1,
       1,    49,    -1,    -1,    23,    10,    66,    50,    67,    51,
      -1,    68,    -1,    67,    68,    -1,    69,    -1,    70,    -1,
      71,    -1,    72,    -1,    84,    -1,    24,    10,    49,    -1,
      24,    10,    52,    10,    53,    49,    -1,    24,    54,    49,
      -1,    24,    54,    52,    10,    53,    49,    -1,    24,    55,
      49,    -1,    24,    55,    52,    10,    53,    49,    -1,    26,
      78,    49,    -1,    27,    56,     9,    49,    -1,    25,    10,
      50,    73,    51,    -1,    74,    56,   103,    29,    77,    -1,
      74,    29,    77,    -1,    75,    -1,    -1,    75,    76,    -1,
      10,    -1,    10,    52,    10,    53,    -1,    78,    -1,    -1,
      78,    79,    -1,    10,    -1,    10,    52,    80,    53,    -1,
      54,    -1,    55,    -1,    81,    82,    -1,    82,    -1,    19,
      10,    56,    -1,    -1,    83,    -1,    82,    57,    83,    -1,
      10,    58,   103,    -1,    28,    50,    85,    51,    -1,    -1,
      85,    86,    -1,    10,    50,    87,    51,    -1,    54,    50,
      87,    51,    -1,    55,    50,    87,    51,    -1,    -1,    87,
      88,    -1,    30,    52,   103,    53,    49,    -1,    38,    52,
      53,    49,    -1,    39,    52,    53,    49,    -1,    35,    52,
     103,    53,    49,    -1,    36,    52,   103,    53,    49,    -1,
      37,    52,   103,    53,    49,    -1,    32,    52,   103,    53,
      49,    -1,    33,    52,   103,    57,   103,    53,    49,    -1,
      34,    52,   103,    57,   103,    57,   103,    53,    49,    -1,
      31,    52,   103,    57,   103,    57,   103,    53,    49,    -1,
      -1,    19,    10,    90,    50,    91,    51,    -1,    -1,    91,
      92,    -1,    91,    96,    -1,     1,    49,    -1,    -1,    11,
      10,    93,    50,    94,    51,    -1,    -1,    94,    95,    -1,
      20,    56,   103,    49,    -1,    21,    56,   103,    49,    -1,
      22,    56,   103,    49,    -1,    12,    10,    50,    97,    98,
      51,    -1,    13,    50,    99,    51,    -1,    14,    50,   102,
      51,    -1,    -1,    99,   100,    -1,    15,    56,   103,    49,
      -1,   101,    56,    16,    52,   103,    57,   103,    53,    49,
      -1,   101,    56,    17,    52,   103,    57,   103,    53,    49,
      -1,    10,    -1,   101,     3,    10,    -1,    18,    56,    10,
      49,    -1,   103,     7,   104,    -1,   104,    -1,   104,     8,
     105,    -1,   105,    -1,    59,   105,    -1,   106,    -1,   106,
      60,   107,    -1,   106,    61,   107,    -1,   106,    40,   107,
      -1,   106,    41,   107,    -1,   106,    42,   107,    -1,   106,
      43,   107,    -1,   107,    -1,   107,     3,   108,    -1,   107,
       4,   108,    -1,   108,    -1,   108,     5,   109,    -1,   108,
       6,   109,    -1,   109,    -1,     9,    -1,    52,   103,    53,
      -1,    44,    52,   103,    57,   103,    53,    -1,    45,    52,
     103,    57,   103,    53,    -1,    46,    52,   103,    57,   103,
      53,    -1,    47,    52,   103,    57,   103,    53,    -1,    48,
      52,   103,    53,    -1,    10,    -1,    10,    62,    10,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   249,   249,   251,   252,   253,   257,   257,   261,   262,
     266,   267,   268,   269,   270,   274,   275,   276,   277,   278,
     279,   283,   287,   291,   295,   296,   300,   304,   305,   309,
     310,   314,   318,   319,   328,   329,   330,   331,   335,   336,
     340,   344,   345,   346,   350,   354,   358,   359,   363,   364,
     365,   369,   370,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   389,   389,   392,   394,   395,   396,   400,
     400,   404,   406,   410,   411,   412,   416,   420,   424,   428,
     429,   433,   434,   435,   439,   440,   444,   448,   449,   453,
     454,   458,   459,   463,   464,   465,   466,   467,   468,   469,
     473,   474,   475,   479,   480,   481,   486,   487,   488,   489,
     490,   491,   492,   493,   494
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "'+'", "'-'", "'*'", "'/'", "LOGICAL_OR",
  "LOGICAL_AND", "REALVALUE", "IDENTIFIER", "FACTOR_DEF", "GENE_DEF",
  "PROMOTER_DEF", "PRODUCT_DEF", "CONSTITUTIVE", "ACTIVATE", "REPRESS",
  "DEFAULT", "TRANSSYS_DEF", "DECAY_DEF", "DIFFUSIBILITY_DEF",
  "SYNTHESIS_DEF", "LSYS_DEF", "SYMBOL_DEF", "RULE_DEF", "AXIOM_DEF",
  "DIFFUSIONRANGE_DEF", "GRAPHICS_DEF", "ARROW", "MOVE", "COLOR", "SPHERE",
  "CYLINDER", "BOX", "TURN", "ROLL", "BANK", "PUSH", "POP", "LOWER_EQUAL",
  "GREATER_EQUAL", "EQUAL", "UNEQUAL", "NUMERIC_RANDOM", "NUMERIC_GAUSS",
  "NUMERIC_POW", "NUMERIC_LOG", "NUMERIC_ATAN", "';'", "'{'", "'}'", "'('",
  "')'", "'['", "']'", "':'", "','", "'='", "'!'", "'<'", "'>'", "'.'",
  "$accept", "ltrfile", "lsys", "$@1", "lsys_element_list", "lsys_element",
  "symbol_definition", "axiom_definition", "diffusionrange_definition",
  "rule_definition", "rule_components", "rule_lhs", "lhs_element_string",
  "lhs_element", "rule_rhs", "production_element_string",
  "production_element", "transsys_initializer",
  "source_transsys_specifier", "assignment_list", "assignment",
  "graphics_definition", "symgraph_list", "symgraph", "graphcmd_list",
  "graphcmd", "transsys", "$@2", "transsys_element_list",
  "factor_definition", "$@3", "factordef_components",
  "factordef_component", "gene_definition", "promoter_component",
  "product_component", "promoter_statements", "promoter_statement",
  "factor_combination", "product_statements", "expr", "and_expr",
  "not_expr", "cmp_expr", "arithmetic_expr", "term", "value", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,    43,    45,    42,    47,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,    59,
     123,   125,    40,    41,    91,    93,    58,    44,    61,    33,
      60,    62,    46
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    63,    64,    64,    64,    64,    66,    65,    67,    67,
      68,    68,    68,    68,    68,    69,    69,    69,    69,    69,
      69,    70,    71,    72,    73,    73,    74,    75,    75,    76,
      76,    77,    78,    78,    79,    79,    79,    79,    80,    80,
      81,    82,    82,    82,    83,    84,    85,    85,    86,    86,
      86,    87,    87,    88,    88,    88,    88,    88,    88,    88,
      88,    88,    88,    90,    89,    91,    91,    91,    91,    93,
      92,    94,    94,    95,    95,    95,    96,    97,    98,    99,
      99,   100,   100,   100,   101,   101,   102,   103,   103,   104,
     104,   105,   105,   106,   106,   106,   106,   106,   106,   106,
     107,   107,   107,   108,   108,   108,   109,   109,   109,   109,
     109,   109,   109,   109,   109
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     0,     2,     2,     2,     0,     6,     1,     2,
       1,     1,     1,     1,     1,     3,     6,     3,     6,     3,
       6,     3,     4,     5,     5,     3,     1,     0,     2,     1,
       4,     1,     0,     2,     1,     4,     1,     1,     2,     1,
       3,     0,     1,     3,     3,     4,     0,     2,     4,     4,
       4,     0,     2,     5,     4,     4,     5,     5,     5,     5,
       7,     9,     9,     0,     6,     0,     2,     2,     2,     0,
       6,     0,     2,     4,     4,     4,     6,     4,     4,     0,
       2,     4,     9,     9,     1,     3,     4,     3,     1,     3,
       1,     2,     1,     3,     3,     3,     3,     3,     3,     1,
       3,     3,     1,     3,     3,     1,     1,     3,     6,     6,
       6,     6,     4,     1,     3
};

/* YYDEFACT[STATE-NAME] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       0,     0,     0,     5,     1,     0,     0,     3,     4,    63,
       6,     0,     0,     0,     0,     0,     0,     0,     0,    32,
       0,     0,     0,     8,    10,    11,    12,    13,    14,    68,
       0,     0,    64,    66,    67,     0,     0,     0,     0,     0,
       0,    46,     7,     9,    69,     0,    15,     0,    17,     0,
      19,     0,    27,    34,    21,    36,    37,    33,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    26,    41,    22,
       0,    45,     0,     0,    47,    71,     0,     0,     0,     0,
       0,    23,    32,     0,    29,    28,     0,     0,     0,    41,
      39,    42,    51,    51,    51,     0,    79,     0,     0,    16,
      18,    20,    25,    31,   106,   113,     0,     0,     0,     0,
       0,     0,     0,     0,    88,    90,    92,    99,   102,   105,
       0,     0,     0,    35,    38,     0,     0,     0,     0,     0,
       0,     0,    70,    72,     0,     0,    76,     0,     0,     0,
       0,     0,     0,     0,    91,     0,    32,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    44,
      40,    43,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    48,    52,    49,    50,     0,     0,     0,    84,
       0,    77,    80,     0,     0,     0,   114,     0,     0,     0,
       0,     0,   107,    87,    24,    89,    95,    96,    97,    98,
      93,    94,   100,   101,   103,   104,    30,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    78,     0,     0,     0,     0,   112,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      73,    74,    75,     0,    85,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      54,    55,    81,     0,     0,    86,   108,   109,   110,   111,
      53,     0,    59,     0,     0,    56,    57,    58,     0,     0,
       0,     0,     0,     0,     0,     0,    60,     0,     0,     0,
       0,     0,     0,     0,    62,    61,    82,    83
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     2,     7,    12,    22,    23,    24,    25,    26,    27,
      65,    66,    67,    85,   102,   103,    57,    88,    89,    90,
      91,    28,    59,    74,   126,   173,     8,    11,    16,    33,
      60,    95,   133,    34,    77,    98,   134,   182,   183,   185,
     113,   114,   115,   116,   117,   118,   119
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -112
static const yytype_int16 yypact[] =
{
     177,   -38,   151,  -112,  -112,    63,   100,  -112,  -112,  -112,
    -112,   -33,    88,     4,   163,    38,   125,    66,   131,  -112,
      69,    93,   134,  -112,  -112,  -112,  -112,  -112,  -112,  -112,
     153,   158,  -112,  -112,  -112,   -27,    56,    83,   149,    64,
     212,  -112,  -112,  -112,  -112,   179,  -112,   220,  -112,   221,
    -112,   235,  -112,   194,  -112,  -112,  -112,  -112,   198,    73,
     199,   237,   195,   200,   202,   201,    48,   241,   121,  -112,
     206,  -112,   207,   208,  -112,  -112,   209,   246,   213,   214,
     215,  -112,  -112,    -7,   216,  -112,   211,   251,   217,   255,
     210,  -112,  -112,  -112,  -112,   135,  -112,   222,   223,  -112,
    -112,  -112,  -112,    75,  -112,   204,   219,   224,   225,   226,
     227,    -7,    -7,    46,   265,  -112,   183,    20,   161,  -112,
     270,    -7,   228,  -112,   210,   255,   171,   181,   203,   229,
     230,   231,  -112,  -112,   124,   257,  -112,   271,    -7,    -7,
      -7,    -7,    -7,    -3,  -112,    -7,  -112,    -7,   102,   102,
     102,   102,   102,   102,   102,   102,   102,   102,   236,   275,
    -112,  -112,   238,   239,   240,   242,   243,   244,   245,   247,
     248,   249,  -112,  -112,  -112,  -112,    -7,    -7,    -7,  -112,
     232,  -112,  -112,    -2,   250,   252,  -112,    -1,     0,     1,
       2,    19,  -112,   265,  -112,  -112,    20,    20,    20,    20,
      20,    20,   161,   161,  -112,  -112,  -112,    -7,    -7,    -7,
      -7,    -7,    -7,    -7,    -7,   254,   256,    77,    84,   115,
      -7,   273,   176,   283,  -112,    -7,    -7,    -7,    -7,  -112,
      25,     5,    26,     6,     7,    27,    28,    29,   253,   259,
    -112,  -112,  -112,   116,  -112,   258,   260,   262,    35,    36,
      37,    39,   264,    -7,   266,    -7,    -7,   267,   268,   269,
    -112,  -112,  -112,    -7,    -7,  -112,  -112,  -112,  -112,  -112,
    -112,    11,  -112,    40,    12,  -112,  -112,  -112,    13,    14,
      -7,   272,    -7,    -7,    -7,    41,  -112,    42,    53,    54,
     274,   276,   277,   278,  -112,  -112,  -112,  -112
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -112,  -112,  -112,  -112,  -112,   282,  -112,  -112,  -112,  -112,
    -112,  -112,  -112,  -112,   152,   286,  -112,  -112,  -112,   233,
     189,  -112,  -112,  -112,   101,  -112,  -112,  -112,  -112,  -112,
    -112,  -112,  -112,  -112,  -112,  -112,  -112,  -112,  -112,  -112,
    -111,   174,   -61,  -112,    31,    43,    71
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -66
static const yytype_int16 yytable[] =
{
     143,   221,   104,   105,   145,    15,   145,   145,   145,   145,
     159,     3,   145,   145,   145,   -65,   -65,    13,   145,   145,
     145,   145,    46,   154,   155,    47,   145,   187,   188,   189,
     190,   191,   145,   145,   145,   145,   145,   106,   107,   108,
     109,   110,   145,   145,   145,   111,   145,   145,   145,   145,
     192,   144,   112,   145,   222,   -65,   225,   226,   227,   228,
     145,   145,   253,   255,   256,   217,   218,   219,   280,   282,
     283,   284,   229,     9,    53,   146,    35,    82,   252,   254,
     257,   258,   259,    70,   145,    53,   195,    29,   266,   267,
     268,   145,   269,   281,   290,   291,   230,   231,   232,   233,
     234,   235,   236,   237,    83,    48,   292,   293,    49,   243,
      10,   104,   105,    54,   248,   249,   250,   251,    55,    56,
      36,    37,   145,   145,    71,    40,   240,    72,    73,    55,
      56,    86,    50,   241,   179,    51,    30,    31,    14,   180,
      87,    38,   271,    41,   273,   274,   106,   107,   108,   109,
     110,     4,   278,   279,   111,   129,   130,   131,    17,    18,
      19,    20,    21,    44,   242,   262,   156,   157,    45,   285,
       5,   287,   288,   289,     6,   181,    32,    -2,     1,   196,
     197,   198,   199,   200,   201,    42,   132,    17,    18,    19,
      20,    21,   245,   246,   127,   128,    -2,   202,   203,    52,
      -2,   162,   163,   164,   165,   166,   167,   168,   169,   170,
     171,   162,   163,   164,   165,   166,   167,   168,   169,   170,
     171,    58,   172,   148,   149,   150,   151,   204,   205,    61,
      62,    63,   174,   162,   163,   164,   165,   166,   167,   168,
     169,   170,   171,   152,   153,    64,    68,    69,    78,    75,
      76,    84,    81,    79,   175,    80,    92,    93,    94,    96,
      97,   122,    99,   100,   101,    86,   137,   125,   120,   121,
     123,   138,   135,   147,   136,   184,   139,   140,   141,   142,
     158,   186,   145,   244,   160,   176,   177,   178,   220,   206,
     207,   208,   209,   247,   210,   211,   212,   213,   194,   214,
     215,   216,   260,   224,    43,    39,   223,   238,   261,   239,
     263,   265,   264,   270,   161,   272,   275,   276,   277,   193,
       0,   286,   124,   294,     0,   295,   296,   297
};

#define yypact_value_is_default(yystate) \
  ((yystate) == (-112))

#define yytable_value_is_error(yytable_value) \
  YYID (0)

static const yytype_int16 yycheck[] =
{
     111,     3,     9,    10,     7,     1,     7,     7,     7,     7,
     121,    49,     7,     7,     7,    11,    12,    50,     7,     7,
       7,     7,    49,     3,     4,    52,     7,   138,   139,   140,
     141,   142,     7,     7,     7,     7,     7,    44,    45,    46,
      47,    48,     7,     7,     7,    52,     7,     7,     7,     7,
      53,   112,    59,     7,    56,    51,    57,    57,    57,    57,
       7,     7,    57,    57,    57,   176,   177,   178,    57,    57,
      57,    57,    53,    10,    10,    29,    10,    29,    53,    53,
      53,    53,    53,    10,     7,    10,   147,    49,    53,    53,
      53,     7,    53,    53,    53,    53,   207,   208,   209,   210,
     211,   212,   213,   214,    56,    49,    53,    53,    52,   220,
      10,     9,    10,    49,   225,   226,   227,   228,    54,    55,
      54,    55,     7,     7,    51,    56,    49,    54,    55,    54,
      55,    10,    49,    49,    10,    52,    11,    12,    50,    15,
      19,    10,   253,    50,   255,   256,    44,    45,    46,    47,
      48,     0,   263,   264,    52,    20,    21,    22,    24,    25,
      26,    27,    28,    10,    49,    49,     5,     6,    10,   280,
      19,   282,   283,   284,    23,    51,    51,     0,     1,   148,
     149,   150,   151,   152,   153,    51,    51,    24,    25,    26,
      27,    28,    16,    17,    93,    94,    19,   154,   155,    50,
      23,    30,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    30,    31,    32,    33,    34,    35,    36,    37,    38,
      39,     9,    51,    40,    41,    42,    43,   156,   157,    50,
      10,    10,    51,    30,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    60,    61,    10,    52,    49,    53,    50,
      13,    10,    51,    53,    51,    53,    50,    50,    50,    50,
      14,    10,    49,    49,    49,    10,    62,    57,    52,    58,
      53,    52,    50,     8,    51,    18,    52,    52,    52,    52,
      10,    10,     7,    10,    56,    56,    56,    56,    56,    53,
      52,    52,    52,    10,    52,    52,    52,    52,   146,    52,
      52,    52,    49,    51,    22,    19,    56,    53,    49,    53,
      52,    49,    52,    49,   125,    49,    49,    49,    49,   145,
      -1,    49,    89,    49,    -1,    49,    49,    49
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,     1,    64,    49,     0,    19,    23,    65,    89,    10,
      10,    90,    66,    50,    50,     1,    91,    24,    25,    26,
      27,    28,    67,    68,    69,    70,    71,    72,    84,    49,
      11,    12,    51,    92,    96,    10,    54,    55,    10,    78,
      56,    50,    51,    68,    10,    10,    49,    52,    49,    52,
      49,    52,    50,    10,    49,    54,    55,    79,     9,    85,
      93,    50,    10,    10,    10,    73,    74,    75,    52,    49,
      10,    51,    54,    55,    86,    50,    13,    97,    53,    53,
      53,    51,    29,    56,    10,    76,    10,    19,    80,    81,
      82,    83,    50,    50,    50,    94,    50,    14,    98,    49,
      49,    49,    77,    78,     9,    10,    44,    45,    46,    47,
      48,    52,    59,   103,   104,   105,   106,   107,   108,   109,
      52,    58,    10,    53,    82,    57,    87,    87,    87,    20,
      21,    22,    51,    95,    99,    50,    51,    62,    52,    52,
      52,    52,    52,   103,   105,     7,    29,     8,    40,    41,
      42,    43,    60,    61,     3,     4,     5,     6,    10,   103,
      56,    83,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    51,    88,    51,    51,    56,    56,    56,    10,
      15,    51,   100,   101,    18,   102,    10,   103,   103,   103,
     103,   103,    53,   104,    77,   105,   107,   107,   107,   107,
     107,   107,   108,   108,   109,   109,    53,    52,    52,    52,
      52,    52,    52,    52,    52,    52,    52,   103,   103,   103,
      56,     3,    56,    56,    51,    57,    57,    57,    57,    53,
     103,   103,   103,   103,   103,   103,   103,   103,    53,    53,
      49,    49,    49,   103,    10,    16,    17,    10,   103,   103,
     103,   103,    53,    57,    53,    57,    57,    53,    53,    53,
      49,    49,    49,    52,    52,    49,    53,    53,    53,    53,
      49,   103,    49,   103,   103,    49,    49,    49,   103,   103,
      57,    53,    57,    57,    57,   103,    49,   103,   103,   103,
      53,    53,    53,    53,    49,    49,    49,    49
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  However,
   YYFAIL appears to be in use.  Nevertheless, it is formally deprecated
   in Bison 2.4.2's NEWS entry, where a plan to phase it out is
   discussed.  */

#define YYFAIL		goto yyerrlab
#if defined YYFAIL
  /* This is here to suppress warnings from the GCC cpp's
     -Wunused-macros.  Normally we don't worry about that warning, but
     some users do, and we want to make it easy for users to remove
     YYFAIL uses, which will produce warnings from Bison 2.5.  */
#endif

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      YYPOPSTACK (1);						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (YYID (N))                                                    \
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (YYID (0))
#endif


/* This macro is provided for backward compatibility. */

#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
	break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yyrule)
    YYSTYPE *yyvsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       		       );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (0, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  YYSIZE_T yysize1;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = 0;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - Assume YYFAIL is not used.  It's too flawed to consider.  See
       <http://lists.gnu.org/archive/html/bison-patches/2009-12/msg00024.html>
       for details.  YYERROR is fine as it does not invoke this
       function.
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                yysize1 = yysize + yytnamerr (0, yytname[yyx]);
                if (! (yysize <= yysize1
                       && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                  return 2;
                yysize = yysize1;
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  yysize1 = yysize + yystrlen (yyformat);
  if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
    return 2;
  yysize = yysize1;

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yymsg, yytype, yyvaluep)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  YYUSE (yyvaluep);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
	break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */
#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */


/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.

       Refer to the stacks thru separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yytoken = 0;
  yyss = yyssa;
  yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */
  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  *++yyvsp = yylval;

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 3:

/* Line 1806 of yacc.c  */
#line 251 "trbison.y"
    { parsed_lsys = add_lsys(parsed_lsys, current_lsys); if (parsed_lsys == NULL) YYABORT; }
    break;

  case 4:

/* Line 1806 of yacc.c  */
#line 252 "trbison.y"
    { parsed_transsys  = add_transsys(parsed_transsys, current_transsys); if (parsed_transsys == NULL) YYABORT; }
    break;

  case 5:

/* Line 1806 of yacc.c  */
#line 253 "trbison.y"
    { yyerrok; }
    break;

  case 6:

/* Line 1806 of yacc.c  */
#line 257 "trbison.y"
    { setup_current_lsys((yyvsp[(2) - (2)].identifier)); }
    break;

  case 7:

/* Line 1806 of yacc.c  */
#line 257 "trbison.y"
    {}
    break;

  case 8:

/* Line 1806 of yacc.c  */
#line 261 "trbison.y"
    {}
    break;

  case 9:

/* Line 1806 of yacc.c  */
#line 262 "trbison.y"
    {}
    break;

  case 10:

/* Line 1806 of yacc.c  */
#line 266 "trbison.y"
    { add_symbol_definition(current_lsys, (yyvsp[(1) - (1)].symbol_element)); }
    break;

  case 11:

/* Line 1806 of yacc.c  */
#line 267 "trbison.y"
    { add_axiom_definition(current_lsys, (yyvsp[(1) - (1)].symbol_production)); }
    break;

  case 12:

/* Line 1806 of yacc.c  */
#line 268 "trbison.y"
    { add_diffusionrange_definition(current_lsys, (yyvsp[(1) - (1)].real)); }
    break;

  case 13:

/* Line 1806 of yacc.c  */
#line 269 "trbison.y"
    { if (add_rule_definition(current_lsys, (yyvsp[(1) - (1)].rule_element)) != 0) YYABORT; }
    break;

  case 14:

/* Line 1806 of yacc.c  */
#line 270 "trbison.y"
    {}
    break;

  case 15:

/* Line 1806 of yacc.c  */
#line 274 "trbison.y"
    { (yyval.symbol_element) = create_symbol_element((yyvsp[(2) - (3)].identifier), NULL, parsed_transsys); if ((yyval.symbol_element) == NULL) YYABORT; }
    break;

  case 16:

/* Line 1806 of yacc.c  */
#line 275 "trbison.y"
    { (yyval.symbol_element) = create_symbol_element((yyvsp[(2) - (6)].identifier), (yyvsp[(4) - (6)].identifier), parsed_transsys); if ((yyval.symbol_element) == NULL) YYABORT; }
    break;

  case 17:

/* Line 1806 of yacc.c  */
#line 276 "trbison.y"
    { (yyval.symbol_element) = create_symbol_element("[", NULL, parsed_transsys); if ((yyval.symbol_element) == NULL) YYABORT; }
    break;

  case 18:

/* Line 1806 of yacc.c  */
#line 277 "trbison.y"
    { (yyval.symbol_element) = create_symbol_element("[", (yyvsp[(4) - (6)].identifier), parsed_transsys); if ((yyval.symbol_element) == NULL) YYABORT; }
    break;

  case 19:

/* Line 1806 of yacc.c  */
#line 278 "trbison.y"
    { (yyval.symbol_element) = create_symbol_element("]", NULL, parsed_transsys); if ((yyval.symbol_element) == NULL) YYABORT; }
    break;

  case 20:

/* Line 1806 of yacc.c  */
#line 279 "trbison.y"
    { (yyval.symbol_element) = create_symbol_element("]", (yyvsp[(4) - (6)].identifier), parsed_transsys); if ((yyval.symbol_element) == NULL) YYABORT; }
    break;

  case 21:

/* Line 1806 of yacc.c  */
#line 283 "trbison.y"
    { (yyval.symbol_production) = new_symbol_production((yyvsp[(2) - (3)].production_element)); }
    break;

  case 22:

/* Line 1806 of yacc.c  */
#line 287 "trbison.y"
    { (yyval.real) = (yyvsp[(3) - (4)].real); }
    break;

  case 23:

/* Line 1806 of yacc.c  */
#line 291 "trbison.y"
    { (yyval.rule_element) = complete_rule((yyvsp[(2) - (5)].identifier), (yyvsp[(4) - (5)].rule_element)); }
    break;

  case 24:

/* Line 1806 of yacc.c  */
#line 295 "trbison.y"
    { (yyval.rule_element) = new_rule_element(NULL, (yyvsp[(1) - (5)].lhs_descriptor), (yyvsp[(3) - (5)].expression), (yyvsp[(5) - (5)].symbol_production)); }
    break;

  case 25:

/* Line 1806 of yacc.c  */
#line 296 "trbison.y"
    { (yyval.rule_element) = new_rule_element(NULL, (yyvsp[(1) - (3)].lhs_descriptor), NULL, (yyvsp[(3) - (3)].symbol_production)); }
    break;

  case 26:

/* Line 1806 of yacc.c  */
#line 300 "trbison.y"
    { (yyval.lhs_descriptor) = create_lhs_descriptor(current_lsys, (yyvsp[(1) - (1)].lhs_symbol)); current_lhs_symbol_list = (yyval.lhs_descriptor)->symbol_list; }
    break;

  case 27:

/* Line 1806 of yacc.c  */
#line 304 "trbison.y"
    { (yyval.lhs_symbol) = (LHS_SYMBOL *) NULL; }
    break;

  case 28:

/* Line 1806 of yacc.c  */
#line 305 "trbison.y"
    { (yyval.lhs_symbol) = add_lhs_symbol((yyvsp[(1) - (2)].lhs_symbol), (yyvsp[(2) - (2)].lhs_symbol)); }
    break;

  case 29:

/* Line 1806 of yacc.c  */
#line 309 "trbison.y"
    { (yyval.lhs_symbol) = create_lhs_symbol((yyvsp[(1) - (1)].identifier), NULL, current_lsys); if ((yyval.lhs_symbol) == NULL) YYABORT; }
    break;

  case 30:

/* Line 1806 of yacc.c  */
#line 310 "trbison.y"
    { (yyval.lhs_symbol) = create_lhs_symbol((yyvsp[(1) - (4)].identifier), (yyvsp[(3) - (4)].identifier), current_lsys); if ((yyval.lhs_symbol) == NULL) YYABORT; }
    break;

  case 31:

/* Line 1806 of yacc.c  */
#line 314 "trbison.y"
    { (yyval.symbol_production) = new_symbol_production((yyvsp[(1) - (1)].production_element)); }
    break;

  case 32:

/* Line 1806 of yacc.c  */
#line 318 "trbison.y"
    { (yyval.production_element) = (PRODUCTION_ELEMENT *) NULL; }
    break;

  case 33:

/* Line 1806 of yacc.c  */
#line 319 "trbison.y"
    { (yyval.production_element) = add_production_element((yyvsp[(1) - (2)].production_element), (yyvsp[(2) - (2)].production_element)); }
    break;

  case 34:

/* Line 1806 of yacc.c  */
#line 328 "trbison.y"
    { (yyval.production_element) = create_production_element((yyvsp[(1) - (1)].identifier), NULL, current_lsys, current_lhs_symbol_list); if ((yyval.production_element) == NULL) YYABORT; }
    break;

  case 35:

/* Line 1806 of yacc.c  */
#line 329 "trbison.y"
    { (yyval.production_element) = create_production_element((yyvsp[(1) - (4)].identifier), (yyvsp[(3) - (4)].raw_assignment), current_lsys, current_lhs_symbol_list); if ((yyval.production_element) == NULL) YYABORT; }
    break;

  case 36:

/* Line 1806 of yacc.c  */
#line 330 "trbison.y"
    { (yyval.production_element) = create_production_element("[", NULL, current_lsys, current_lhs_symbol_list); if ((yyval.production_element) == NULL) YYABORT; }
    break;

  case 37:

/* Line 1806 of yacc.c  */
#line 331 "trbison.y"
    { (yyval.production_element) = create_production_element("]", NULL, current_lsys, current_lhs_symbol_list); if ((yyval.production_element) == NULL) YYABORT; }
    break;

  case 38:

/* Line 1806 of yacc.c  */
#line 335 "trbison.y"
    { (yyval.raw_assignment) = add_raw_assignment((yyvsp[(2) - (2)].raw_assignment), (yyvsp[(1) - (2)].raw_assignment)); }
    break;

  case 39:

/* Line 1806 of yacc.c  */
#line 336 "trbison.y"
    { (yyval.raw_assignment) = (yyvsp[(1) - (1)].raw_assignment); }
    break;

  case 40:

/* Line 1806 of yacc.c  */
#line 340 "trbison.y"
    { (yyval.raw_assignment) = create_raw_assignment(NULL, (yyvsp[(2) - (3)].identifier), NULL); }
    break;

  case 41:

/* Line 1806 of yacc.c  */
#line 344 "trbison.y"
    { (yyval.raw_assignment) = (RAW_ASSIGNMENT *) NULL; }
    break;

  case 42:

/* Line 1806 of yacc.c  */
#line 345 "trbison.y"
    { (yyval.raw_assignment) = (yyvsp[(1) - (1)].raw_assignment); }
    break;

  case 43:

/* Line 1806 of yacc.c  */
#line 346 "trbison.y"
    { (yyval.raw_assignment) = add_raw_assignment((yyvsp[(1) - (3)].raw_assignment), (yyvsp[(3) - (3)].raw_assignment)); }
    break;

  case 44:

/* Line 1806 of yacc.c  */
#line 350 "trbison.y"
    { (yyval.raw_assignment) = create_raw_assignment((yyvsp[(1) - (3)].identifier), NULL, (yyvsp[(3) - (3)].expression)); }
    break;

  case 45:

/* Line 1806 of yacc.c  */
#line 354 "trbison.y"
    {}
    break;

  case 46:

/* Line 1806 of yacc.c  */
#line 358 "trbison.y"
    {}
    break;

  case 47:

/* Line 1806 of yacc.c  */
#line 359 "trbison.y"
    {}
    break;

  case 48:

/* Line 1806 of yacc.c  */
#line 363 "trbison.y"
    { add_graphics_to_named_symbol(current_lsys, (yyvsp[(1) - (4)].identifier), (yyvsp[(3) - (4)].graphics_primitive)); }
    break;

  case 49:

/* Line 1806 of yacc.c  */
#line 364 "trbison.y"
    { add_graphics_to_named_symbol(current_lsys, "[", (yyvsp[(3) - (4)].graphics_primitive)); }
    break;

  case 50:

/* Line 1806 of yacc.c  */
#line 365 "trbison.y"
    { add_graphics_to_named_symbol(current_lsys, "]", (yyvsp[(3) - (4)].graphics_primitive)); }
    break;

  case 51:

/* Line 1806 of yacc.c  */
#line 369 "trbison.y"
    { (yyval.graphics_primitive) = (GRAPHICS_PRIMITIVE *) NULL; }
    break;

  case 52:

/* Line 1806 of yacc.c  */
#line 370 "trbison.y"
    { (yyval.graphics_primitive) = add_graphics_primitive((yyvsp[(1) - (2)].graphics_primitive), (yyvsp[(2) - (2)].graphics_primitive)); }
    break;

  case 53:

/* Line 1806 of yacc.c  */
#line 374 "trbison.y"
    { (yyval.graphics_primitive) = new_graphics_primitive(GRAPHICS_MOVE, (yyvsp[(3) - (5)].expression)); }
    break;

  case 54:

/* Line 1806 of yacc.c  */
#line 375 "trbison.y"
    { (yyval.graphics_primitive) = new_graphics_primitive(GRAPHICS_PUSH, NULL); }
    break;

  case 55:

/* Line 1806 of yacc.c  */
#line 376 "trbison.y"
    { (yyval.graphics_primitive) = new_graphics_primitive(GRAPHICS_POP, NULL); }
    break;

  case 56:

/* Line 1806 of yacc.c  */
#line 377 "trbison.y"
    { (yyval.graphics_primitive) = new_graphics_primitive(GRAPHICS_TURN, (yyvsp[(3) - (5)].expression)); }
    break;

  case 57:

/* Line 1806 of yacc.c  */
#line 378 "trbison.y"
    { (yyval.graphics_primitive) = new_graphics_primitive(GRAPHICS_ROLL, (yyvsp[(3) - (5)].expression)); }
    break;

  case 58:

/* Line 1806 of yacc.c  */
#line 379 "trbison.y"
    { (yyval.graphics_primitive) = new_graphics_primitive(GRAPHICS_BANK, (yyvsp[(3) - (5)].expression)); }
    break;

  case 59:

/* Line 1806 of yacc.c  */
#line 380 "trbison.y"
    { (yyval.graphics_primitive) = new_graphics_primitive(GRAPHICS_SPHERE, (yyvsp[(3) - (5)].expression)); }
    break;

  case 60:

/* Line 1806 of yacc.c  */
#line 381 "trbison.y"
    { (yyval.graphics_primitive) = new_graphics_primitive(GRAPHICS_CYLINDER, (yyvsp[(3) - (7)].expression), (yyvsp[(5) - (7)].expression)); }
    break;

  case 61:

/* Line 1806 of yacc.c  */
#line 382 "trbison.y"
    { (yyval.graphics_primitive) = new_graphics_primitive(GRAPHICS_BOX, (yyvsp[(3) - (9)].expression), (yyvsp[(5) - (9)].expression), (yyvsp[(7) - (9)].expression)); }
    break;

  case 62:

/* Line 1806 of yacc.c  */
#line 383 "trbison.y"
    { (yyval.graphics_primitive) = new_graphics_primitive(GRAPHICS_COLOR, (yyvsp[(3) - (9)].expression), (yyvsp[(5) - (9)].expression), (yyvsp[(7) - (9)].expression)); }
    break;

  case 63:

/* Line 1806 of yacc.c  */
#line 389 "trbison.y"
    { setup_current_transsys((yyvsp[(2) - (2)].identifier)); }
    break;

  case 64:

/* Line 1806 of yacc.c  */
#line 389 "trbison.y"
    {}
    break;

  case 66:

/* Line 1806 of yacc.c  */
#line 394 "trbison.y"
    { add_factor_definition(current_transsys, (yyvsp[(2) - (2)].factor)); }
    break;

  case 67:

/* Line 1806 of yacc.c  */
#line 395 "trbison.y"
    { add_gene_definition(current_transsys, (yyvsp[(2) - (2)].gene)); }
    break;

  case 68:

/* Line 1806 of yacc.c  */
#line 396 "trbison.y"
    { yyerrok; }
    break;

  case 69:

/* Line 1806 of yacc.c  */
#line 400 "trbison.y"
    { setup_current_factor((yyvsp[(2) - (2)].identifier)); }
    break;

  case 70:

/* Line 1806 of yacc.c  */
#line 400 "trbison.y"
    { (yyval.factor) = current_factor; }
    break;

  case 73:

/* Line 1806 of yacc.c  */
#line 410 "trbison.y"
    { if (set_factordef_decay((yyvsp[(3) - (4)].expression), current_factor) != 0) YYABORT; }
    break;

  case 74:

/* Line 1806 of yacc.c  */
#line 411 "trbison.y"
    { if (set_factordef_diffusibility((yyvsp[(3) - (4)].expression), current_factor) != 0) YYABORT; }
    break;

  case 75:

/* Line 1806 of yacc.c  */
#line 412 "trbison.y"
    { if (set_factordef_synthesis((yyvsp[(3) - (4)].expression), current_factor) != 0) YYABORT; }
    break;

  case 76:

/* Line 1806 of yacc.c  */
#line 416 "trbison.y"
    { (yyval.gene) = create_gene((yyvsp[(2) - (6)].identifier), (yyvsp[(4) - (6)].promoter), (yyvsp[(5) - (6)].integer)); }
    break;

  case 77:

/* Line 1806 of yacc.c  */
#line 420 "trbison.y"
    { (yyval.promoter) = (yyvsp[(3) - (4)].promoter); }
    break;

  case 78:

/* Line 1806 of yacc.c  */
#line 424 "trbison.y"
    { (yyval.integer) = (yyvsp[(3) - (4)].integer); }
    break;

  case 79:

/* Line 1806 of yacc.c  */
#line 428 "trbison.y"
    { (yyval.promoter) = (PROMOTER_ELEMENT *) NULL; }
    break;

  case 80:

/* Line 1806 of yacc.c  */
#line 429 "trbison.y"
    { (yyval.promoter) = extend_promoter_list((yyvsp[(1) - (2)].promoter), (yyvsp[(2) - (2)].promoter)); }
    break;

  case 81:

/* Line 1806 of yacc.c  */
#line 433 "trbison.y"
    { (yyval.promoter) = create_promoter(PROMOTERELEMENT_CONSTITUTIVE, NULL, (yyvsp[(3) - (4)].expression), NULL); }
    break;

  case 82:

/* Line 1806 of yacc.c  */
#line 434 "trbison.y"
    { (yyval.promoter) = create_promoter(PROMOTERELEMENT_ACTIVATE, (yyvsp[(1) - (9)].intarr), (yyvsp[(5) - (9)].expression), (yyvsp[(7) - (9)].expression)); }
    break;

  case 83:

/* Line 1806 of yacc.c  */
#line 435 "trbison.y"
    { (yyval.promoter) = create_promoter(PROMOTERELEMENT_REPRESS, (yyvsp[(1) - (9)].intarr), (yyvsp[(5) - (9)].expression), (yyvsp[(7) - (9)].expression)); }
    break;

  case 84:

/* Line 1806 of yacc.c  */
#line 439 "trbison.y"
    { (yyval.intarr) = extend_factor_combination(NULL, (yyvsp[(1) - (1)].identifier), current_transsys); if ((yyval.intarr) == NULL) YYABORT; }
    break;

  case 85:

/* Line 1806 of yacc.c  */
#line 440 "trbison.y"
    { (yyval.intarr) = extend_factor_combination((yyvsp[(1) - (3)].intarr), (yyvsp[(3) - (3)].identifier), current_transsys); if ((yyval.intarr) == NULL) YYABORT; }
    break;

  case 86:

/* Line 1806 of yacc.c  */
#line 444 "trbison.y"
    { (yyval.integer) = find_factor_index(current_transsys, (yyvsp[(3) - (4)].identifier)); }
    break;

  case 87:

/* Line 1806 of yacc.c  */
#line 448 "trbison.y"
    { (yyval.expression) = new_expression_node(NT_LOGICAL_OR, (yyvsp[(1) - (3)].expression), (yyvsp[(3) - (3)].expression)); }
    break;

  case 88:

/* Line 1806 of yacc.c  */
#line 449 "trbison.y"
    { (yyval.expression) = (yyvsp[(1) - (1)].expression); }
    break;

  case 89:

/* Line 1806 of yacc.c  */
#line 453 "trbison.y"
    { (yyval.expression) = new_expression_node(NT_LOGICAL_AND, (yyvsp[(1) - (3)].expression), (yyvsp[(3) - (3)].expression)); }
    break;

  case 90:

/* Line 1806 of yacc.c  */
#line 454 "trbison.y"
    { (yyval.expression) = (yyvsp[(1) - (1)].expression); }
    break;

  case 91:

/* Line 1806 of yacc.c  */
#line 458 "trbison.y"
    { (yyval.expression) = new_expression_node(NT_NOT, (yyvsp[(2) - (2)].expression)); }
    break;

  case 92:

/* Line 1806 of yacc.c  */
#line 459 "trbison.y"
    { (yyval.expression) = (yyvsp[(1) - (1)].expression); }
    break;

  case 93:

/* Line 1806 of yacc.c  */
#line 463 "trbison.y"
    { (yyval.expression) = new_expression_node(NT_LOWER, (yyvsp[(1) - (3)].expression), (yyvsp[(3) - (3)].expression)); }
    break;

  case 94:

/* Line 1806 of yacc.c  */
#line 464 "trbison.y"
    { (yyval.expression) = new_expression_node(NT_GREATER, (yyvsp[(1) - (3)].expression), (yyvsp[(3) - (3)].expression)); }
    break;

  case 95:

/* Line 1806 of yacc.c  */
#line 465 "trbison.y"
    { (yyval.expression) = new_expression_node(NT_LOWER_EQUAL, (yyvsp[(1) - (3)].expression), (yyvsp[(3) - (3)].expression)); }
    break;

  case 96:

/* Line 1806 of yacc.c  */
#line 466 "trbison.y"
    { (yyval.expression) = new_expression_node(NT_GREATER_EQUAL, (yyvsp[(1) - (3)].expression), (yyvsp[(3) - (3)].expression)); }
    break;

  case 97:

/* Line 1806 of yacc.c  */
#line 467 "trbison.y"
    { (yyval.expression) = new_expression_node(NT_EQUAL, (yyvsp[(1) - (3)].expression), (yyvsp[(3) - (3)].expression)); }
    break;

  case 98:

/* Line 1806 of yacc.c  */
#line 468 "trbison.y"
    { (yyval.expression) = new_expression_node(NT_UNEQUAL, (yyvsp[(1) - (3)].expression), (yyvsp[(3) - (3)].expression)); }
    break;

  case 99:

/* Line 1806 of yacc.c  */
#line 469 "trbison.y"
    { (yyval.expression) = (yyvsp[(1) - (1)].expression); }
    break;

  case 100:

/* Line 1806 of yacc.c  */
#line 473 "trbison.y"
    { (yyval.expression) = new_expression_node(NT_ADD, (yyvsp[(1) - (3)].expression), (yyvsp[(3) - (3)].expression)); }
    break;

  case 101:

/* Line 1806 of yacc.c  */
#line 474 "trbison.y"
    { (yyval.expression) = new_expression_node(NT_SUBTRACT, (yyvsp[(1) - (3)].expression), (yyvsp[(3) - (3)].expression)); }
    break;

  case 102:

/* Line 1806 of yacc.c  */
#line 475 "trbison.y"
    { (yyval.expression) = (yyvsp[(1) - (1)].expression); }
    break;

  case 103:

/* Line 1806 of yacc.c  */
#line 479 "trbison.y"
    { (yyval.expression) = new_expression_node(NT_MULT, (yyvsp[(1) - (3)].expression), (yyvsp[(3) - (3)].expression)); }
    break;

  case 104:

/* Line 1806 of yacc.c  */
#line 480 "trbison.y"
    { (yyval.expression) = new_expression_node(NT_DIV, (yyvsp[(1) - (3)].expression), (yyvsp[(3) - (3)].expression)); }
    break;

  case 105:

/* Line 1806 of yacc.c  */
#line 481 "trbison.y"
    { (yyval.expression) = (yyvsp[(1) - (1)].expression); }
    break;

  case 106:

/* Line 1806 of yacc.c  */
#line 486 "trbison.y"
    { (yyval.expression) = new_expression_node(NT_VALUE, (yyvsp[(1) - (1)].real)); }
    break;

  case 107:

/* Line 1806 of yacc.c  */
#line 487 "trbison.y"
    { (yyval.expression) = (yyvsp[(2) - (3)].expression); }
    break;

  case 108:

/* Line 1806 of yacc.c  */
#line 488 "trbison.y"
    { (yyval.expression) = new_expression_node(NT_RANDOM, (yyvsp[(3) - (6)].expression), (yyvsp[(5) - (6)].expression)); }
    break;

  case 109:

/* Line 1806 of yacc.c  */
#line 489 "trbison.y"
    { (yyval.expression) = new_expression_node(NT_GAUSS, (yyvsp[(3) - (6)].expression), (yyvsp[(5) - (6)].expression)); }
    break;

  case 110:

/* Line 1806 of yacc.c  */
#line 490 "trbison.y"
    { (yyval.expression) = new_expression_node(NT_POW, (yyvsp[(3) - (6)].expression), (yyvsp[(5) - (6)].expression)); }
    break;

  case 111:

/* Line 1806 of yacc.c  */
#line 491 "trbison.y"
    { (yyval.expression) = new_expression_node(NT_LOG, (yyvsp[(3) - (6)].expression), (yyvsp[(5) - (6)].expression)); }
    break;

  case 112:

/* Line 1806 of yacc.c  */
#line 492 "trbison.y"
    { (yyval.expression) = new_expression_node(NT_ATAN, (yyvsp[(3) - (4)].expression)); }
    break;

  case 113:

/* Line 1806 of yacc.c  */
#line 493 "trbison.y"
    { (yyval.expression) = new_expression_node(NT_RAW_IDENTIFIER, NULL, (yyvsp[(1) - (1)].identifier)); }
    break;

  case 114:

/* Line 1806 of yacc.c  */
#line 494 "trbison.y"
    { (yyval.expression) = new_expression_node(NT_RAW_IDENTIFIER,(yyvsp[(1) - (3)].identifier), (yyvsp[(3) - (3)].identifier)); }
    break;



/* Line 1806 of yacc.c  */
#line 2676 "trbison.c"
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  *++yyvsp = yylval;


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined(yyoverflow) || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}



/* Line 2067 of yacc.c  */
#line 497 "trbison.y"



void yyerror(const char *s, ...)
{
  va_list arglist;

  va_start(arglist, s);
  fprintf(stderr, "%s:%ld: ", yyin_name, lineno);
  vfprintf(stderr, s, arglist);
  fprintf(stderr, "\n");
  switch (yychar)
  {
  case REALVALUE:
    fprintf(stderr, "    token: REALVALUE:\n");
    break;
  case IDENTIFIER:
    fprintf(stderr, "    token: IDENTIFIER:\n");
    break;
  case FACTOR_DEF:
    fprintf(stderr, "    token: FACTOR_DEF:\n");
    break;
  case GENE_DEF:
    fprintf(stderr, "    token: GENE_DEF:\n");
    break;
  case PROMOTER_DEF:
    fprintf(stderr, "    token: PROMOTER_DEF:\n");
    break;
  case PRODUCT_DEF:
    fprintf(stderr, "    token: PRODUCT_DEF:\n");
    break;
  case CONSTITUTIVE:
    fprintf(stderr, "    token: CONSTITUTIVE:\n");
    break;
  case ACTIVATE:
    fprintf(stderr, "    token: ACTIVATE:\n");
    break;
  case REPRESS:
    fprintf(stderr, "    token: REPRESS:\n");
    break;
  case DEFAULT:
    fprintf(stderr, "    token: DEFAULT:\n");
    break;
  case NUMERIC_RANDOM:
    fprintf(stderr, "    token: NUMERIC_RANDOM:\n");
    break;
  case NUMERIC_GAUSS:
    fprintf(stderr, "    token: NUMERIC_GAUSS:\n");
    break;
  case NUMERIC_POW:
    fprintf(stderr, "    token: NUMERIC_POW:\n");
    break;
  case NUMERIC_LOG:
    fprintf(stderr, "    token: NUMERIC_LOG:\n");
    break;
  case NUMERIC_ATAN:
    fprintf(stderr, "    token: NUMERIC_ATAN:\n");
    break;
  case TRANSSYS_DEF:
    fprintf(stderr, "    token: TRANSSYS_DEF:\n");
    break;
  case DECAY_DEF:
    fprintf(stderr, "    token: DECAY_DEF:\n");
    break;
  case DIFFUSIBILITY_DEF:
    fprintf(stderr, "    token: DIFFUSIBILITY_DEF:\n");
    break;
  case DIFFUSIONRANGE_DEF:
    fprintf(stderr, "    token: DIFFUSIONRANGE_DEF:\n");
    break;
  case LSYS_DEF:
    fprintf(stderr, "    token: LSYS_DEF:\n");
    break;
  case SYMBOL_DEF:
    fprintf(stderr, "    token: SYMBOL_DEF:\n");
    break;
  case RULE_DEF:
    fprintf(stderr, "    token: RULE_DEF:\n");
    break;
  case AXIOM_DEF:
    fprintf(stderr, "    token: AXIOM_DEF:\n");
    break;
  case GRAPHICS_DEF:
    fprintf(stderr, "    token: GRAPHICS_DEF:\n");
    break;
  case ARROW:
    fprintf(stderr, "    token: ARROW:\n");
    break;
  case MOVE:
    fprintf(stderr, "    token: MOVE:\n");
    break;
  case COLOR:
    fprintf(stderr, "    token: COLOR:\n");
    break;
  case SPHERE:
    fprintf(stderr, "    token: SPHERE:\n");
    break;
  case CYLINDER:
    fprintf(stderr, "    token: CYLINDER:\n");
    break;
  case BOX:
    fprintf(stderr, "    token: BOX:\n");
    break;
  case TURN:
    fprintf(stderr, "    token: TURN:\n");
    break;
  case ROLL:
    fprintf(stderr, "    token: ROLL:\n");
    break;
  case BANK:
    fprintf(stderr, "    token: BANK:\n");
    break;
  case LOWER_EQUAL:
    fprintf(stderr, "    token: LOWER_EQUAL:\n");
    break;
  case GREATER_EQUAL:
    fprintf(stderr, "    token: GREATER_EQUAL:\n");
    break;
  case EQUAL:
    fprintf(stderr, "    token: EQUAL:\n");
    break;
  case UNEQUAL:
    fprintf(stderr, "    token: UNEQUAL:\n");
    break;
  case LOGICAL_AND:
    fprintf(stderr, "    token: LOGICAL_AND:\n");
    break;
  case LOGICAL_OR:
    fprintf(stderr, "    token: LOGICAL_OR:\n");
    break;
  default:
    if (yychar < 256)
    {
      if (isprint(yychar))
	fprintf(stderr, "    token: \'%c\'\n", yychar);
      else
	fprintf(stderr, "    token: #%d\n", yychar);
    }
    else
      fprintf(stderr, "    token: #%d\n", yychar);
    break;
  }
}


#ifdef TEST_PARSER

char *yyin_name = "stdin";
TRANSSYS *parsed_transsys = NULL;


int main(int argc, char *argv[])
{
  int retval;

  retval = yyparse();
  printf("\n*** yyparse returned %d ***\n", retval);
  return (0);
}

#endif


